<?php
/**
* @package   BaForms
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla controlleradmin library
jimport('joomla.application.component.controlleradmin');

class BaformsControllerForms extends JControllerAdmin
{
	/**
	 * Proxy for getModel.
	 */
	public function getModel($name = 'form', $prefix = 'baformsModel', $config = array()) 
	{
		$model = parent::getModel($name, $prefix, array('ignore_request' => true));
        return $model;
	}
    
    public function duplicate()
    {
        $pks = $this->input->getVar('cid', array(), 'post', 'array');
        $model = $this->getModel();
        $model->duplicate($pks);
        $this->setMessage(JText::plural('FORM_DUPLICATED', count($pks)));
        $this->setRedirect('index.php?option=com_baforms&view=forms');
    }
    
    public function updateBaforms()
    {
        $target = $_POST['target'];
        $config = JFactory::getConfig();
        $path = $config->get('tmp_path') . '/com_baforms.zip';
        copy($target, $path);
        JArchive::extract($path, $config->get('tmp_path') . '/com_baforms');
        $installer = JInstaller::getInstance();
        $result = $installer->update($config->get('tmp_path') . '/com_baforms');
        JFile::delete($path);
        JFolder::delete( $config->get('tmp_path') . '/com_baforms' );
        $verion = baformsHelper::aboutUs();
        if ($result) {
            echo new JResponseJson($result, $verion->version);
        } else {
            echo new JResponseJson($result, '', true);
        }
        jexit();
    }
}