<?php
/**
* @package   BaForms
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

jimport( 'joomla.plugin.plugin' );
jimport('joomla.filesystem.folder');
 
class plgSystemBaforms extends JPlugin
{
    /**
    * Constructor.
    *
    * @access protected
    * @param object $subject The object to observe
    * @param array   $config  An array that holds the plugin configuration
    * @since 1.0
    */
    
    public function __construct( &$subject, $config )
    {
        $doc = JFactory::getDocument();
        if ($doc->getType() != 'html') {
            return;
        }
        parent::__construct( $subject, $config );
    }

    function onAfterInitialise()
    {
        $app = JFactory::getApplication();
        if ($app->isSite()) {
            $path = JPATH_ROOT . '/components/com_baforms/helpers/baforms.php';
            $dir = $this->checkOverride();
            if ($dir) {
                $path = $dir;
            }
            JLoader::register('baformsHelper', $path);
        }
    }
    
    public function checkOverride()
    {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('template')
            ->from('#__template_styles')
            ->where('`client_id`=0')
            ->where('`home`=1');
        $db->setQuery($query);
        $template = $db->loadResult();
        $path = JPATH_ROOT. '/templates/' .$template. '/html/com_baforms';
        if (JFolder::exists($path)) {
            if (JFolder::exists($path. '/helpers')) {
                $file = JFolder::files($path. '/helpers', 'baforms.php');
                if (!empty($file)) {
                    return $path. '/helpers/baforms.php';
                } else {
                    return false;
                }
            } else {
                return false;
            }
        } else {
            return false;
        }
        
    }
    
    function onBeforeCompileHead()
    {
        $app = JFactory::getApplication();
        if ($app->isSite()) {
            $loaded = JLoader::getClassList();
            if (isset($loaded['baformshelper'])) {
                baformsHelper::addStyle();
            }
        }
    }

    function onAfterRoute()
    {
    }
    
    function onAfterDispatch()
    {
    }

    function onAfterRender()
    {
        $app = JFactory::getApplication();
        if ($app->isSite()) {
            $loaded = JLoader::getClassList();
            if (isset($loaded['baformshelper'])) {
                $html = JResponse::getBody();
                $html_split = explode('<body', $html, 2);
                $pre = $html_split['0'];
                $body = '<body' . $html_split['1'];
                $body_split = explode('</body>', $body);
                $post = array_pop($body_split);
                $body = implode('</body>', $body_split) . '</body>';
                $body = $this->getContent($body);
                $html = $pre . $body . $post;
                JResponse::setBody($html);
            }
        }
    }
    
    function getContent($body)
    {
        $regex = '/\[forms ID=+(.*?)\]/i';
        preg_match_all($regex, $body, $matches, PREG_SET_ORDER);
        if ($matches) {
            foreach ($matches as $index => $match) {
                $form = explode(',', $match[1]);
                $formId = $form[0];
                if (isset($formId)) {
                    if (baformsHelper::checkForm($formId)) {
                        $form = baformsHelper::drawHTMLPage($formId);

                        $body = @preg_replace("|\[forms ID=".$formId."\]|", addcslashes($form, '\\$'), $body, 1);
                    }
                }
                }
        }
        return $body;
    }
}